# Deprecated Interface for Secondary Structure Utilities

  Defines

  STRUC
    #include <ViennaRNA/RNAstruct.h>

  Functions

  char *b2HIT(const char *structure)
    #include <ViennaRNA/RNAstruct.h>

    Converts the full structure from bracket notation to the HIT notation including root.

    Deprecated:

      See vrna_db_to_tree_string() and VRNA_STRUCTURE_TREE_HIT for a replacement

    Parameters:

      - structure –

    Returns:

  char *b2C(const char *structure)
    #include <ViennaRNA/RNAstruct.h>

    Converts the full structure from bracket notation to the a coarse grained notation using the ‘H’ ‘B’ ‘I’ ‘M’ and ‘R’ identifiers.

    Deprecated:

      See vrna_db_to_tree_string() and VRNA_STRUCTURE_TREE_SHAPIRO_SHORT for a replacement

    Parameters:

      - structure –

    Returns:

  char *b2Shapiro(const char *structure)
    #include <ViennaRNA/RNAstruct.h>

    Converts the full structure from bracket notation to the weighted coarse grained notation using the ‘H’ ‘B’ ‘I’ ‘M’ ‘S’ ‘E’ and ‘R’ identifiers.

    Deprecated:

      See vrna_db_to_tree_string() and VRNA_STRUCTURE_TREE_SHAPIRO_WEIGHT for a replacement

    Parameters:

      - structure –

    Returns:

  char *add_root(const char *structure)
    #include <ViennaRNA/RNAstruct.h>

    Adds a root to an un-rooted tree in any except bracket notation.

    Parameters:

      - structure –

    Returns:

  char *expand_Shapiro(const char *coarse)
    #include <ViennaRNA/RNAstruct.h>

    Inserts missing ‘S’ identifiers in unweighted coarse grained structures as obtained from b2C().

    Parameters:

      - coarse –

    Returns:

  char *expand_Full(const char *structure)
    #include <ViennaRNA/RNAstruct.h>

    Convert the full structure from bracket notation to the expanded notation including root.

    Parameters:

      - structure –

    Returns:

  char *unexpand_Full(const char *ffull)
    #include <ViennaRNA/RNAstruct.h>

    Restores the bracket notation from an expanded full or HIT tree, that is any tree using only identifiers ‘U’ ‘P’ and ‘R’.

    Parameters:

      - ffull –

    Returns:

  char *unweight(const char *wcoarse)
    #include <ViennaRNA/RNAstruct.h>

    Strip weights from any weighted tree.

    Parameters:

      - wcoarse –

    Returns:

  void unexpand_aligned_F(char *align[2])
    #include <ViennaRNA/RNAstruct.h>

    Converts two aligned structures in expanded notation.

    Takes two aligned structures as produced by tree_edit_distance() function back to bracket notation with ‘_’ as the gap character. The result overwrites the input.

    Parameters:

      - align –

  void parse_structure(const char *structure)
    #include <ViennaRNA/RNAstruct.h>

    Collects a statistic of structure elements of the full structure in bracket notation.

    The function writes to the following global variables: loop_size, loop_degree, helix_size, loops, pairs, unpaired

    Parameters:

      - structure –

  char *pack_structure(const char *struc)
    #include <ViennaRNA/utils/structures.h>

    Pack secondary secondary structure, 5:1 compression using base 3 encoding.

    Returns a binary string encoding of the secondary structure using a 5:1 compression scheme. The string is NULL terminated and can therefore be used with standard string functions such as strcmp(). Useful for programs that need to keep many structures in memory.

    Deprecated:

      Use vrna_db_pack() as a replacement

    Parameters:

      - struc – The secondary structure in dot-bracket notation

    Returns:

      The binary encoded structure

  char *unpack_structure(const char *packed)
    #include <ViennaRNA/utils/structures.h>

    Unpack secondary structure previously packed with pack_structure()

    Translate a compressed binary string produced by pack_structure() back into the familiar dot-bracket notation.

    Deprecated:

      Use vrna_db_unpack() as a replacement

    Parameters:

      - packed – The binary encoded packed secondary structure

    Returns:

      The unpacked secondary structure in dot-bracket notation

  short *make_pair_table(const char *structure)
    #include <ViennaRNA/utils/structures.h>

    Create a pair table of a secondary structure.

    Returns a newly allocated table, such that table[i]=j if (i.j) pair or 0 if i is unpaired, table[0] contains the length of the structure.

    Deprecated:

      Use vrna_ptable() instead

    Parameters:

      - structure – The secondary structure in dot-bracket notation

    Returns:

      A pointer to the created pair_table

  short *copy_pair_table(const short *pt)
    #include <ViennaRNA/utils/structures.h>

    Get an exact copy of a pair table.

    Deprecated:

      Use vrna_ptable_copy() instead

    Parameters:

      - pt – The pair table to be copied

    Returns:

      A pointer to the copy of ‘pt’

  short *alimake_pair_table(const char *structure)
    #include <ViennaRNA/utils/structures.h>

    Pair table for snoop align

    Deprecated:

      Use vrna_pt_ali_get() instead!

  short *make_pair_table_snoop(const char *structure)
    #include <ViennaRNA/utils/structures.h>

    returns a newly allocated table, such that: table[i]=j if (i.j) pair or 0 if i is unpaired, table[0] contains the length of the structure. The special pseudoknotted H/ACA-mRNA structure is taken into account.

    Deprecated:

      Use vrna_pt_snoop_get() instead!

  int bp_distance(const char *str1, const char *str2)
    #include <ViennaRNA/utils/structures.h>

    Compute the “base pair” distance between two secondary structures s1 and s2.

    The sequences should have the same length. dist = number of base pairs in one structure but not in the other same as edit distance with open-pair close-pair as move-set

    Deprecated:

      Use vrna_bp_distance instead

    Parameters:

      - str1 – First structure in dot-bracket notation

      - str2 – Second structure in dot-bracket notation

    Returns:

      The base pair distance between str1 and str2

  unsigned int *make_referenceBP_array(short *reference_pt, unsigned int turn)
    #include <ViennaRNA/utils/structures.h>

    Make a reference base pair count matrix.

    Get an upper triangular matrix containing the number of basepairs of a reference structure for each interval [i,j] with i<j. Access it via iindx!!!

    Deprecated:

      Use vrna_refBPcnt_matrix() instead

  unsigned int *compute_BPdifferences(short *pt1, short *pt2, unsigned int turn)
    #include <ViennaRNA/utils/structures.h>

    Make a reference base pair distance matrix.

    Get an upper triangular matrix containing the base pair distance of two reference structures for each interval [i,j] with i<j. Access it via iindx!!!

    Deprecated:

      Use vrna_refBPdist_matrix() instead

  void parenthesis_structure(char *structure, vrna_bp_stack_t *bp, int length)
    #include <ViennaRNA/utils/structures.h>

    Create a dot-backet/parenthesis structure from backtracking stack.

    Deprecated:

      use vrna_parenthesis_structure() instead

    Note

    This function is threadsafe

  void parenthesis_zuker(char *structure, vrna_bp_stack_t *bp, int length)
    #include <ViennaRNA/utils/structures.h>

    Create a dot-backet/parenthesis structure from backtracking stack obtained by zuker suboptimal calculation in cofold.c.

    Deprecated:

      use vrna_parenthesis_zuker instead

    Note

    This function is threadsafe

  void bppm_to_structure(char *structure, FLT_OR_DBL *pr, unsigned int length)
    #include <ViennaRNA/utils/structures.h>

    Create a dot-bracket like structure string from base pair probability matrix.

    Deprecated:

      Use vrna_db_from_probs() instead!

  char bppm_symbol(const float *x)
    #include <ViennaRNA/utils/structures.h>

    Get a pseudo dot bracket notation for a given probability information.

    Deprecated:

      Use vrna_bpp_symbol() instead!

  Variables

  int loop_size[ STRUC ]

    contains a list of all loop sizes. loop_size[0] contains the number of external bases.

  int helix_size[ STRUC ]

    contains a list of all stack sizes.

  int loop_degree[ STRUC ]

    contains the corresponding list of loop degrees.

  int loops

    contains the number of loops ( and therefore of stacks ).

  int unpaired

    contains the number of unpaired bases.

  int pairs

    contains the number of base pairs in the last parsed structure.